﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows;
using Telerik.Windows.Controls;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			this.listBox1.ItemsSource = Enumerable.Range(0, 10);
			this.dropDown1.MyKeyDown += new EventHandler<CustomKeyEventArgs>(dropDown1_MyKeyDown);
		}

		void dropDown1_MyKeyDown(object sender, CustomKeyEventArgs e)
		{
			switch (e.Key)
			{
				case Key.Down:
					try
					{
						this.listBox1.SelectedIndex++;
					}
					catch (Exception)
					{
						this.listBox1.SelectedIndex = 1;
					}
					break;
				case Key.Up:
					try
					{
						this.listBox1.SelectedIndex--;
					}
					catch (Exception)
					{
						this.listBox1.SelectedIndex = 1;
					}
					break;
			}
		}

		private void listBox1_SelectionChanged(object sender, System.Windows.Controls.SelectionChangedEventArgs e)
		{
			this.dropDown1.IsOpen = false;
		}
	}

	public class MyDropDown : RadDropDownButton
	{
		protected override void OnKeyDown(KeyEventArgs e)
		{
			if (MyKeyDown != null)
			{
				MyKeyDown(this, new CustomKeyEventArgs(e.Key));
			}
		}

		public event EventHandler<CustomKeyEventArgs> MyKeyDown;
	}

	public class CustomKeyEventArgs : EventArgs
	{
		public CustomKeyEventArgs(Key key)
		{
			this.Key = key;
		}
		public Key Key { get; set; }
	}
}
